Replace nodegroups' PartialNic by PartialNicParams
[ganeti-local] / Makefile.am
index 39271b5..1ee6f5e 100644 (file)
@@ -23,6 +23,7 @@ RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
 CHECK_HEADER = $(top_srcdir)/autotools/check-header
 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
+CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
 CHECK_VERSION = $(top_srcdir)/autotools/check-version
 CHECK_NEWS = $(top_srcdir)/autotools/check-news
@@ -54,39 +55,40 @@ myexeclibdir = $(pkglibdir)
 # Delete output file if an error occurred while building it
 .DELETE_ON_ERROR:
 
-HTOOLS_DIRS = \
-       htools \
-       htools/Ganeti \
-       htools/Ganeti/Block \
-       htools/Ganeti/Block/Drbd \
-       htools/Ganeti/Confd \
-       htools/Ganeti/DataCollectors \
-       htools/Ganeti/HTools \
-       htools/Ganeti/HTools/Backend \
-       htools/Ganeti/HTools/Program \
-       htools/Ganeti/Query \
-       htest \
-       htest/Test \
-       htest/Test/Ganeti \
-       htest/Test/Ganeti/Block \
-       htest/Test/Ganeti/Block/Drbd \
-       htest/Test/Ganeti/Confd \
-       htest/Test/Ganeti/HTools \
-       htest/Test/Ganeti/HTools/Backend \
-       htest/Test/Ganeti/Query
+HS_DIRS = \
+       src \
+       src/Ganeti \
+       src/Ganeti/Block \
+       src/Ganeti/Block/Drbd \
+       src/Ganeti/Confd \
+       src/Ganeti/DataCollectors \
+       src/Ganeti/HTools \
+       src/Ganeti/HTools/Backend \
+       src/Ganeti/HTools/Program \
+       src/Ganeti/Query \
+       test/hs \
+       test/hs/Test \
+       test/hs/Test/Ganeti \
+       test/hs/Test/Ganeti/Block \
+       test/hs/Test/Ganeti/Block/Drbd \
+       test/hs/Test/Ganeti/Confd \
+       test/hs/Test/Ganeti/HTools \
+       test/hs/Test/Ganeti/HTools/Backend \
+       test/hs/Test/Ganeti/Query
 
 DIRS = \
-       $(HTOOLS_DIRS) \
+       $(HS_DIRS) \
        autotools \
        daemons \
        devel \
        doc \
+       doc/css \
        doc/examples \
        doc/examples/gnt-debug \
        doc/examples/hooks \
-       htest/data \
-       htest/data/rapi \
-       htest/shelltests \
+       test/data/htools \
+       test/data/htools/rapi \
+       test/hs/shelltests \
        lib \
        lib/build \
        lib/client \
@@ -106,6 +108,7 @@ DIRS = \
        test/data \
        test/data/ovfdata \
        test/data/ovfdata/other \
+       test/py \
        tools
 
 ALL_APIDOC_HS_DIRS = \
@@ -149,7 +152,6 @@ APIDOC_PY_DIR = $(APIDOC_DIR)/py
 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
 
 MAINTAINERCLEANFILES = \
-       $(docpng) \
        $(maninput) \
        doc/install-quick.rst \
        doc/news.rst \
@@ -161,8 +163,8 @@ maintainer-clean-local:
 
 CLEANFILES = \
        $(addsuffix /*.py[co],$(DIRS)) \
-       $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
-       $(addsuffix /*.o,$(HTOOLS_DIRS)) \
+       $(addsuffix /*.hi,$(HS_DIRS)) \
+       $(addsuffix /*.o,$(HS_DIRS)) \
        $(PYTHON_BOOTSTRAP) \
        epydoc.conf \
        $(REPLACE_VARS_SED) \
@@ -182,8 +184,8 @@ CLEANFILES = \
        $(nodist_pkgpython_PYTHON) \
        $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
        $(HS_BUILT_TEST_HELPERS) \
-       htools/ganeti-confd \
-       .hpc/*.mix htools/*.tix htest/*.tix \
+       src/ganeti-confd \
+       .hpc/*.mix src/*.tix test/hs/*.tix \
        doc/hs-lint.html
 
 GENERATED_FILES = \
@@ -191,11 +193,11 @@ GENERATED_FILES = \
        $(BUILT_PYTHON_SOURCES) \
        $(PYTHON_BOOTSTRAP)
 
-HTOOLS_GENERATED_FILES =
+HS_GENERATED_FILES =
 if WANT_HTOOLS
-HTOOLS_GENERATED_FILES += $(HS_PROGS)
+HS_GENERATED_FILES += $(HS_PROGS)
 if ENABLE_CONFD
-HTOOLS_GENERATED_FILES += htools/hconfd htools/ganeti-confd
+HS_GENERATED_FILES += src/hconfd src/ganeti-confd
 endif
 endif
 
@@ -282,7 +284,8 @@ client_PYTHON = \
        lib/client/gnt_job.py \
        lib/client/gnt_node.py \
        lib/client/gnt_network.py \
-       lib/client/gnt_os.py
+       lib/client/gnt_os.py \
+       lib/client/gnt_storage.py
 
 hypervisor_PYTHON = \
        lib/hypervisor/__init__.py \
@@ -354,7 +357,9 @@ utils_PYTHON = \
        lib/utils/wrapper.py \
        lib/utils/x509.py
 
-docrst = \
+docinput = \
+       doc/conf.py \
+       doc/css/style.css \
        doc/admin.rst \
        doc/cluster-merge.rst \
        doc/design-2.0.rst \
@@ -407,30 +412,43 @@ docrst = \
        doc/virtual-cluster.rst \
        doc/walkthrough.rst
 
-HS_PROGS = htools/htools htools/mon-collector
+# Haskell programs to be installed in $PREFIX/bin
+HS_BIN_PROGS=src/htools
+
+# Haskell programs to be installed in the MYEXECLIB dir
+HS_MYEXECLIB_PROGS=src/mon-collector
+
+# Haskell programs to compiled but not installed automatically
+# Usually they have their own specific installation rules
+HS_COMPILE_PROGS= \
+       src/hconfd \
+       src/rpc-test
+
+# All Haskell non-test programs to be compiled but not automatically installed
+HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
+
 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
 
 HS_ALL_PROGS = \
        $(HS_PROGS) \
-       htest/hpc-htools \
-       htest/hpc-mon-collector \
-       htest/test \
-       htools/hconfd \
-       htools/rpc-test
+       test/hs/hpc-htools \
+       test/hs/hpc-mon-collector \
+       test/hs/htest \
+       $(HS_COMPILE_PROGS)
 
 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
-HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
+HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
 
 HFLAGS = \
-       -O -Wall -Werror -ihtools \
+       -O -Wall -Werror -isrc \
        -fwarn-monomorphism-restriction \
        -fwarn-tabs \
        $(GHC_BYVERSION_FLAGS)
 
 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
 HEXTRA =
-# internal extra flags (used for htest/test mainly)
+# internal extra flags (used for test/hs/htest mainly)
 HEXTRA_INT =
 # exclude options for coverage reports
 HPCEXCL = --exclude Main \
@@ -443,121 +461,121 @@ HPCEXCL = --exclude Main \
        --exclude Test.Ganeti.TestHTools \
        --exclude Test.Ganeti.TestHelper \
        --exclude Test.Ganeti.TestImports \
-       $(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
+       $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
 
 HS_LIB_SRCS = \
-       htools/Ganeti/Block/Drbd/Types.hs \
-       htools/Ganeti/Block/Drbd/Parser.hs \
-       htools/Ganeti/BasicTypes.hs \
-       htools/Ganeti/Common.hs \
-       htools/Ganeti/Compat.hs \
-       htools/Ganeti/Confd/Client.hs \
-       htools/Ganeti/Confd/Server.hs \
-       htools/Ganeti/Confd/Types.hs \
-       htools/Ganeti/Confd/Utils.hs \
-       htools/Ganeti/Config.hs \
-       htools/Ganeti/Daemon.hs \
-       htools/Ganeti/DataCollectors/CLI.hs \
-       htools/Ganeti/DataCollectors/Drbd.hs \
-       htools/Ganeti/DataCollectors/Program.hs \
-       htools/Ganeti/Errors.hs \
-       htools/Ganeti/HTools/Backend/IAlloc.hs \
-       htools/Ganeti/HTools/Backend/Luxi.hs \
-       htools/Ganeti/HTools/Backend/Rapi.hs \
-       htools/Ganeti/HTools/Backend/Simu.hs \
-       htools/Ganeti/HTools/Backend/Text.hs \
-       htools/Ganeti/HTools/CLI.hs \
-       htools/Ganeti/HTools/Cluster.hs \
-       htools/Ganeti/HTools/Container.hs \
-       htools/Ganeti/HTools/ExtLoader.hs \
-       htools/Ganeti/HTools/Graph.hs \
-       htools/Ganeti/HTools/Group.hs \
-       htools/Ganeti/HTools/Instance.hs \
-       htools/Ganeti/HTools/Loader.hs \
-       htools/Ganeti/HTools/Node.hs \
-       htools/Ganeti/HTools/PeerMap.hs \
-       htools/Ganeti/HTools/Program.hs \
-       htools/Ganeti/HTools/Program/Hail.hs \
-       htools/Ganeti/HTools/Program/Hbal.hs \
-       htools/Ganeti/HTools/Program/Hcheck.hs \
-       htools/Ganeti/HTools/Program/Hinfo.hs \
-       htools/Ganeti/HTools/Program/Hscan.hs \
-       htools/Ganeti/HTools/Program/Hspace.hs \
-       htools/Ganeti/HTools/Program/Hroller.hs \
-       htools/Ganeti/HTools/Types.hs \
-       htools/Ganeti/Hash.hs \
-       htools/Ganeti/JQueue.hs \
-       htools/Ganeti/JSON.hs \
-       htools/Ganeti/Jobs.hs \
-       htools/Ganeti/Logging.hs \
-       htools/Ganeti/Luxi.hs \
-       htools/Ganeti/Network.hs \
-       htools/Ganeti/Objects.hs \
-       htools/Ganeti/OpCodes.hs \
-       htools/Ganeti/OpParams.hs \
-       htools/Ganeti/Path.hs \
-       htools/Ganeti/Query/Common.hs \
-       htools/Ganeti/Query/Filter.hs \
-       htools/Ganeti/Query/Group.hs \
-       htools/Ganeti/Query/Job.hs \
-       htools/Ganeti/Query/Language.hs \
-       htools/Ganeti/Query/Node.hs \
-       htools/Ganeti/Query/Query.hs \
-       htools/Ganeti/Query/Server.hs \
-       htools/Ganeti/Query/Types.hs \
-       htools/Ganeti/Rpc.hs \
-       htools/Ganeti/Runtime.hs \
-       htools/Ganeti/Ssconf.hs \
-       htools/Ganeti/THH.hs \
-       htools/Ganeti/Types.hs \
-       htools/Ganeti/Utils.hs
+       src/Ganeti/Block/Drbd/Types.hs \
+       src/Ganeti/Block/Drbd/Parser.hs \
+       src/Ganeti/BasicTypes.hs \
+       src/Ganeti/Common.hs \
+       src/Ganeti/Compat.hs \
+       src/Ganeti/Confd/Client.hs \
+       src/Ganeti/Confd/Server.hs \
+       src/Ganeti/Confd/Types.hs \
+       src/Ganeti/Confd/Utils.hs \
+       src/Ganeti/Config.hs \
+       src/Ganeti/Daemon.hs \
+       src/Ganeti/DataCollectors/CLI.hs \
+       src/Ganeti/DataCollectors/Drbd.hs \
+       src/Ganeti/DataCollectors/Program.hs \
+       src/Ganeti/Errors.hs \
+       src/Ganeti/HTools/Backend/IAlloc.hs \
+       src/Ganeti/HTools/Backend/Luxi.hs \
+       src/Ganeti/HTools/Backend/Rapi.hs \
+       src/Ganeti/HTools/Backend/Simu.hs \
+       src/Ganeti/HTools/Backend/Text.hs \
+       src/Ganeti/HTools/CLI.hs \
+       src/Ganeti/HTools/Cluster.hs \
+       src/Ganeti/HTools/Container.hs \
+       src/Ganeti/HTools/ExtLoader.hs \
+       src/Ganeti/HTools/Graph.hs \
+       src/Ganeti/HTools/Group.hs \
+       src/Ganeti/HTools/Instance.hs \
+       src/Ganeti/HTools/Loader.hs \
+       src/Ganeti/HTools/Node.hs \
+       src/Ganeti/HTools/PeerMap.hs \
+       src/Ganeti/HTools/Program/Hail.hs \
+       src/Ganeti/HTools/Program/Hbal.hs \
+       src/Ganeti/HTools/Program/Hcheck.hs \
+       src/Ganeti/HTools/Program/Hinfo.hs \
+       src/Ganeti/HTools/Program/Hscan.hs \
+       src/Ganeti/HTools/Program/Hspace.hs \
+       src/Ganeti/HTools/Program/Hroller.hs \
+       src/Ganeti/HTools/Program/Main.hs \
+       src/Ganeti/HTools/Types.hs \
+       src/Ganeti/Hash.hs \
+       src/Ganeti/JQueue.hs \
+       src/Ganeti/JSON.hs \
+       src/Ganeti/Jobs.hs \
+       src/Ganeti/Logging.hs \
+       src/Ganeti/Luxi.hs \
+       src/Ganeti/Network.hs \
+       src/Ganeti/Objects.hs \
+       src/Ganeti/OpCodes.hs \
+       src/Ganeti/OpParams.hs \
+       src/Ganeti/Path.hs \
+       src/Ganeti/Query/Common.hs \
+       src/Ganeti/Query/Filter.hs \
+       src/Ganeti/Query/Group.hs \
+       src/Ganeti/Query/Job.hs \
+       src/Ganeti/Query/Language.hs \
+       src/Ganeti/Query/Node.hs \
+       src/Ganeti/Query/Query.hs \
+       src/Ganeti/Query/Server.hs \
+       src/Ganeti/Query/Types.hs \
+       src/Ganeti/Rpc.hs \
+       src/Ganeti/Runtime.hs \
+       src/Ganeti/Ssconf.hs \
+       src/Ganeti/THH.hs \
+       src/Ganeti/Types.hs \
+       src/Ganeti/Utils.hs
 
 HS_TEST_SRCS = \
-       htest/Test/Ganeti/Attoparsec.hs \
-       htest/Test/Ganeti/BasicTypes.hs \
-       htest/Test/Ganeti/Block/Drbd/Parser.hs \
-       htest/Test/Ganeti/Block/Drbd/Types.hs \
-       htest/Test/Ganeti/Common.hs \
-       htest/Test/Ganeti/Confd/Types.hs \
-       htest/Test/Ganeti/Confd/Utils.hs \
-       htest/Test/Ganeti/Daemon.hs \
-       htest/Test/Ganeti/Errors.hs \
-       htest/Test/Ganeti/HTools/Backend/Simu.hs \
-       htest/Test/Ganeti/HTools/Backend/Text.hs \
-       htest/Test/Ganeti/HTools/CLI.hs \
-       htest/Test/Ganeti/HTools/Cluster.hs \
-       htest/Test/Ganeti/HTools/Container.hs \
-       htest/Test/Ganeti/HTools/Graph.hs \
-       htest/Test/Ganeti/HTools/Instance.hs \
-       htest/Test/Ganeti/HTools/Loader.hs \
-       htest/Test/Ganeti/HTools/Node.hs \
-       htest/Test/Ganeti/HTools/PeerMap.hs \
-       htest/Test/Ganeti/HTools/Types.hs \
-       htest/Test/Ganeti/JSON.hs \
-       htest/Test/Ganeti/Jobs.hs \
-       htest/Test/Ganeti/JQueue.hs \
-       htest/Test/Ganeti/Luxi.hs \
-       htest/Test/Ganeti/Network.hs \
-       htest/Test/Ganeti/Objects.hs \
-       htest/Test/Ganeti/OpCodes.hs \
-       htest/Test/Ganeti/Query/Filter.hs \
-       htest/Test/Ganeti/Query/Language.hs \
-       htest/Test/Ganeti/Query/Query.hs \
-       htest/Test/Ganeti/Rpc.hs \
-       htest/Test/Ganeti/Ssconf.hs \
-       htest/Test/Ganeti/THH.hs \
-       htest/Test/Ganeti/TestCommon.hs \
-       htest/Test/Ganeti/TestHTools.hs \
-       htest/Test/Ganeti/TestHelper.hs \
-       htest/Test/Ganeti/Types.hs \
-       htest/Test/Ganeti/Utils.hs
+       test/hs/Test/Ganeti/Attoparsec.hs \
+       test/hs/Test/Ganeti/BasicTypes.hs \
+       test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
+       test/hs/Test/Ganeti/Block/Drbd/Types.hs \
+       test/hs/Test/Ganeti/Common.hs \
+       test/hs/Test/Ganeti/Confd/Types.hs \
+       test/hs/Test/Ganeti/Confd/Utils.hs \
+       test/hs/Test/Ganeti/Daemon.hs \
+       test/hs/Test/Ganeti/Errors.hs \
+       test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
+       test/hs/Test/Ganeti/HTools/Backend/Text.hs \
+       test/hs/Test/Ganeti/HTools/CLI.hs \
+       test/hs/Test/Ganeti/HTools/Cluster.hs \
+       test/hs/Test/Ganeti/HTools/Container.hs \
+       test/hs/Test/Ganeti/HTools/Graph.hs \
+       test/hs/Test/Ganeti/HTools/Instance.hs \
+       test/hs/Test/Ganeti/HTools/Loader.hs \
+       test/hs/Test/Ganeti/HTools/Node.hs \
+       test/hs/Test/Ganeti/HTools/PeerMap.hs \
+       test/hs/Test/Ganeti/HTools/Types.hs \
+       test/hs/Test/Ganeti/JSON.hs \
+       test/hs/Test/Ganeti/Jobs.hs \
+       test/hs/Test/Ganeti/JQueue.hs \
+       test/hs/Test/Ganeti/Luxi.hs \
+       test/hs/Test/Ganeti/Network.hs \
+       test/hs/Test/Ganeti/Objects.hs \
+       test/hs/Test/Ganeti/OpCodes.hs \
+       test/hs/Test/Ganeti/Query/Filter.hs \
+       test/hs/Test/Ganeti/Query/Language.hs \
+       test/hs/Test/Ganeti/Query/Query.hs \
+       test/hs/Test/Ganeti/Rpc.hs \
+       test/hs/Test/Ganeti/Ssconf.hs \
+       test/hs/Test/Ganeti/THH.hs \
+       test/hs/Test/Ganeti/TestCommon.hs \
+       test/hs/Test/Ganeti/TestHTools.hs \
+       test/hs/Test/Ganeti/TestHelper.hs \
+       test/hs/Test/Ganeti/Types.hs \
+       test/hs/Test/Ganeti/Utils.hs
 
 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
 
 HS_BUILT_SRCS = \
-       htest/Test/Ganeti/TestImports.hs \
-       htools/Ganeti/Constants.hs \
-       htools/Ganeti/Version.hs
+       test/hs/Test/Ganeti/TestImports.hs \
+       src/Ganeti/Constants.hs \
+       src/Ganeti/Version.hs
 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
 
 $(RUN_IN_TEMPDIR): | stamp-directories
@@ -567,9 +585,10 @@ $(RUN_IN_TEMPDIR): | stamp-directories
 # has to exist in order for the sphinx module to be loaded
 # successfully, but we certainly don't want the docs to be rebuilt if
 # it changes
-doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
+doc/html/index.html: $(docinput) doc/conf.py configure.ac \
        $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
        lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
+       doc/css/style.css \
        | $(BUILT_PYTHON_SOURCES)
        @test -n "$(SPHINX)" || \
            { echo 'sphinx-build' not found during configure; exit 1; }
@@ -578,7 +597,8 @@ doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
            -d . \
            -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
            -D release="$(PACKAGE_VERSION)" \
-           $(abs_top_srcdir)/doc $(CURDIR)/doc/html
+           -D graphviz_dot="$(DOT)" \
+           $(abs_top_builddir)/doc $(CURDIR)/doc/html
        rm -f doc/html/.buildinfo doc/html/objects.inv
        touch $@
 
@@ -596,13 +616,6 @@ doc/install-quick.rst doc/news.rst doc/upgrade.rst:
          cat $<; \
        } > $@
 
-docdot = \
-       doc/arch-2.0.dot \
-       doc/design-2.1-lock-acquire.dot \
-       doc/design-2.1-lock-release.dot
-
-docpng = $(patsubst %.dot,%.png,$(docdot))
-
 # Things to build but not to install (add it to EXTRA_DIST if it should be
 # distributed)
 noinst_DATA = \
@@ -621,7 +634,8 @@ gnt_scripts = \
        scripts/gnt-job \
        scripts/gnt-network \
        scripts/gnt-node \
-       scripts/gnt-os
+       scripts/gnt-os \
+       scripts/gnt-storage
 
 PYTHON_BOOTSTRAP_SBIN = \
        daemons/ganeti-masterd \
@@ -656,7 +670,7 @@ qa_scripts = \
 
 bin_SCRIPTS =
 if WANT_HTOOLS
-bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
+bin_SCRIPTS += $(HS_BIN_PROGS)
 install-exec-hook:
        @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
 # FIXME: this is a hardcoded logic, instead of auto-resolving
@@ -668,7 +682,7 @@ install-exec-hook:
 endif
 
 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
-       @if [ "$(notdir $@)" = "test" ] && [ "$(HTOOLS_NODEV)" ]; then \
+       @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
          echo "Error: cannot run unittests without the development" \
               " libraries (see devnotes.rst)" 1>&2; \
          exit 1; \
@@ -676,22 +690,22 @@ $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
        @rm -f $(notdir $@).tix
        $(GHC) --make \
          $(HFLAGS) \
-         $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
+         $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
          -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
          $(HEXTRA) $(HEXTRA_INT) $@
        @touch "$@"
 
-# for the htest/test binary, we need to enable profiling/coverage
-htest/test: HEXTRA_INT=-fhpc -ihtest
+# for the test/hs/htest binary, we need to enable profiling/coverage
+test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
 
 # we compile the hpc-htools binary with the program coverage
-htest/hpc-htools: HEXTRA_INT=-fhpc
+test/hs/hpc-htools: HEXTRA_INT=-fhpc
 
 # we compile the hpc-mon-collector binary with the program coverage
-htest/hpc-mon-collector: HEXTRA_INT=-fhpc
+test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
 
 # test dependency
-htest/offline-tests.sh: htest/hpc-htools htest/hpc-mon-collector
+test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
 
 # rules for building profiling-enabled versions of the haskell
 # programs: hs-prof does the full two-step build, whereas
@@ -723,10 +737,10 @@ nodist_sbin_SCRIPTS = \
        daemons/ganeti-cleaner
 
 if ENABLE_CONFD
-htools/ganeti-confd: htools/hconfd
+src/ganeti-confd: src/hconfd
        cp -f $< $@
 
-nodist_sbin_SCRIPTS += htools/ganeti-confd
+nodist_sbin_SCRIPTS += src/ganeti-confd
 endif
 
 python_scripts = \
@@ -768,7 +782,7 @@ myexeclib_SCRIPTS = \
        daemons/daemon-util \
        tools/kvm-ifup \
        $(pkglib_python_scripts) \
-       htools/mon-collector
+       $(HS_MYEXECLIB_PROGS)
 
 nodist_myexeclib_SCRIPTS = \
        $(nodist_pkglib_python_scripts)
@@ -783,6 +797,7 @@ EXTRA_DIST = \
        autotools/check-header \
        autotools/check-imports \
        autotools/check-man-dashes \
+       autotools/check-man-references \
        autotools/check-man-warnings \
        autotools/check-news \
        autotools/check-python-code \
@@ -790,7 +805,7 @@ EXTRA_DIST = \
        autotools/check-version \
        autotools/convert-constants \
        autotools/docpp \
-       autotools/gen-coverage \
+       autotools/gen-py-coverage \
        autotools/testrunner \
        autotools/wrong-hardcoded-paths \
        $(RUN_IN_TEMPDIR) \
@@ -798,12 +813,10 @@ EXTRA_DIST = \
        daemons/ganeti-cleaner.in \
        $(pkglib_python_scripts) \
        devel/upload \
+       devel/webserver \
        tools/kvm-ifup.in \
        tools/vcluster-setup.in \
-       $(docdot) \
-       $(docpng) \
-       $(docrst) \
-       doc/conf.py \
+       $(docinput) \
        doc/html \
        $(BUILT_EXAMPLES:%=%.in) \
        doc/examples/ganeti.default \
@@ -812,9 +825,9 @@ EXTRA_DIST = \
        doc/examples/gnt-debug/README \
        doc/examples/gnt-debug/delay0.json \
        doc/examples/gnt-debug/delay50.json \
-       test/lockperf.py \
-       test/testutils.py \
-       test/mocks.py \
+       test/py/lockperf.py \
+       test/py/testutils.py \
+       test/py/mocks.py \
        $(dist_TESTS) \
        $(TEST_FILES) \
        man/footer.rst \
@@ -824,9 +837,9 @@ EXTRA_DIST = \
        $(qa_scripts) \
        $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
        $(HS_PROG_SRCS) \
-       htools/lint-hints.hs \
-       htest/cli-tests-defs.sh \
-       htest/offline-test.sh \
+       src/lint-hints.hs \
+       test/hs/cli-tests-defs.sh \
+       test/hs/offline-test.sh \
        .ghci
 
 man_MANS = \
@@ -836,6 +849,7 @@ man_MANS = \
        man/ganeti-masterd.8 \
        man/ganeti-noded.8 \
        man/ganeti-os-interface.7 \
+       man/ganeti-extstorage-interface.7 \
        man/ganeti-rapi.8 \
        man/ganeti-watcher.8 \
        man/ganeti.7 \
@@ -848,6 +862,7 @@ man_MANS = \
        man/gnt-job.8 \
        man/gnt-node.8 \
        man/gnt-os.8 \
+       man/gnt-storage.8 \
        man/hail.1 \
        man/hbal.1 \
        man/hcheck.1 \
@@ -864,36 +879,39 @@ mangen = $(patsubst %.rst,%.gen,$(manrst))
 maninput = \
        $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
        $(patsubst %.html,%.html.in,$(manhtml)) \
-       man/footer.man man/footer.html $(mangen)
+       $(mangen)
 
 TEST_FILES = \
-       htest/data/common-suffix.data \
-       htest/data/hail-alloc-drbd.json \
-       htest/data/hail-change-group.json \
-       htest/data/hail-invalid-reloc.json \
-       htest/data/hail-node-evac.json \
-       htest/data/hail-reloc-drbd.json \
-       htest/data/hbal-excl-tags.data \
-       htest/data/hbal-split-insts.data \
-       htest/data/invalid-node.data \
-       htest/data/missing-resources.data \
-       htest/data/rapi/groups.json \
-       htest/data/rapi/info.json \
-       htest/data/rapi/instances.json \
-       htest/data/rapi/nodes.json \
-       htest/shelltests/htools-balancing.test \
-       htest/shelltests/htools-basic.test \
-       htest/shelltests/htools-dynutil.test \
-       htest/shelltests/htools-excl.test \
-       htest/shelltests/htools-hail.test \
-       htest/shelltests/htools-hspace.test \
-       htest/shelltests/htools-invalid.test \
-       htest/shelltests/htools-multi-group.test \
-       htest/shelltests/htools-no-backend.test \
-       htest/shelltests/htools-rapi.test \
-       htest/shelltests/htools-single-group.test \
-       htest/shelltests/htools-text-backend.test \
-       htest/shelltests/htools-mon-collector.test \
+       test/data/htools/clean-nonzero-score.data \
+       test/data/htools/common-suffix.data \
+       test/data/htools/empty-cluster.data \
+       test/data/htools/hail-alloc-drbd.json \
+       test/data/htools/hail-change-group.json \
+       test/data/htools/hail-invalid-reloc.json \
+       test/data/htools/hail-node-evac.json \
+       test/data/htools/hail-reloc-drbd.json \
+       test/data/htools/hbal-excl-tags.data \
+       test/data/htools/hbal-split-insts.data \
+       test/data/htools/invalid-node.data \
+       test/data/htools/missing-resources.data \
+       test/data/htools/n1-failure.data \
+       test/data/htools/rapi/groups.json \
+       test/data/htools/rapi/info.json \
+       test/data/htools/rapi/instances.json \
+       test/data/htools/rapi/nodes.json \
+       test/hs/shelltests/htools-balancing.test \
+       test/hs/shelltests/htools-basic.test \
+       test/hs/shelltests/htools-dynutil.test \
+       test/hs/shelltests/htools-excl.test \
+       test/hs/shelltests/htools-hail.test \
+       test/hs/shelltests/htools-hspace.test \
+       test/hs/shelltests/htools-invalid.test \
+       test/hs/shelltests/htools-multi-group.test \
+       test/hs/shelltests/htools-no-backend.test \
+       test/hs/shelltests/htools-rapi.test \
+       test/hs/shelltests/htools-single-group.test \
+       test/hs/shelltests/htools-text-backend.test \
+       test/hs/shelltests/htools-mon-collector.test \
        test/data/bdev-drbd-8.0.txt \
        test/data/bdev-drbd-8.3.txt \
        test/data/bdev-drbd-disk.txt \
@@ -901,6 +919,7 @@ TEST_FILES = \
        test/data/bdev-drbd-net-ip6.txt \
        test/data/cert1.pem \
        test/data/cert2.pem \
+       test/data/instance-minor-pairing.txt \
        test/data/ip-addr-show-dummy0.txt \
        test/data/ip-addr-show-lo-ipv4.txt \
        test/data/ip-addr-show-lo-ipv6.txt \
@@ -911,7 +930,9 @@ TEST_FILES = \
        test/data/kvm_0.12.5_help.txt \
        test/data/kvm_0.15.90_help.txt \
        test/data/kvm_0.9.1_help.txt \
+       test/data/kvm_0.9.1_help_boot_test.txt \
        test/data/kvm_1.0_help.txt \
+       test/data/kvm_1.1.2_help.txt \
        test/data/ovfdata/compr_disk.vmdk.gz \
        test/data/ovfdata/config.ini \
        test/data/ovfdata/corrupted_resources.ovf \
@@ -949,109 +970,110 @@ TEST_FILES = \
        test/data/vgreduce-removemissing-2.02.66-ok.txt \
        test/data/vgs-missing-pvs-2.02.02.txt \
        test/data/vgs-missing-pvs-2.02.66.txt \
-       test/ganeti-cli.test \
-       test/gnt-cli.test \
-       test/import-export_unittest-helper
+       test/py/ganeti-cli.test \
+       test/py/gnt-cli.test \
+       test/py/import-export_unittest-helper
 
 python_tests = \
        doc/examples/rapi_testutils.py \
-       test/cfgupgrade_unittest.py \
-       test/docs_unittest.py \
-       test/ganeti.asyncnotifier_unittest.py \
-       test/ganeti.backend_unittest-runasroot.py \
-       test/ganeti.backend_unittest.py \
-       test/ganeti.bdev_unittest.py \
-       test/ganeti.cli_unittest.py \
-       test/ganeti.client.gnt_cluster_unittest.py \
-       test/ganeti.client.gnt_instance_unittest.py \
-       test/ganeti.client.gnt_job_unittest.py \
-       test/ganeti.cmdlib_unittest.py \
-       test/ganeti.compat_unittest.py \
-       test/ganeti.confd.client_unittest.py \
-       test/ganeti.config_unittest.py \
-       test/ganeti.constants_unittest.py \
-       test/ganeti.daemon_unittest.py \
-       test/ganeti.errors_unittest.py \
-       test/ganeti.hooks_unittest.py \
-       test/ganeti.ht_unittest.py \
-       test/ganeti.http_unittest.py \
-       test/ganeti.hypervisor.hv_chroot_unittest.py \
-       test/ganeti.hypervisor.hv_fake_unittest.py \
-       test/ganeti.hypervisor.hv_kvm_unittest.py \
-       test/ganeti.hypervisor.hv_lxc_unittest.py \
-       test/ganeti.hypervisor.hv_xen_unittest.py \
-       test/ganeti.hypervisor_unittest.py \
-       test/ganeti.impexpd_unittest.py \
-       test/ganeti.jqueue_unittest.py \
-       test/ganeti.jstore_unittest.py \
-       test/ganeti.locking_unittest.py \
-       test/ganeti.luxi_unittest.py \
-       test/ganeti.masterd.iallocator_unittest.py \
-       test/ganeti.masterd.instance_unittest.py \
-       test/ganeti.mcpu_unittest.py \
-       test/ganeti.netutils_unittest.py \
-       test/ganeti.objects_unittest.py \
-       test/ganeti.objectutils_unittest.py \
-       test/ganeti.opcodes_unittest.py \
-       test/ganeti.ovf_unittest.py \
-       test/ganeti.qlang_unittest.py \
-       test/ganeti.query_unittest.py \
-       test/ganeti.rapi.baserlib_unittest.py \
-       test/ganeti.rapi.client_unittest.py \
-       test/ganeti.rapi.resources_unittest.py \
-       test/ganeti.rapi.rlib2_unittest.py \
-       test/ganeti.rapi.testutils_unittest.py \
-       test/ganeti.rpc_unittest.py \
-       test/ganeti.runtime_unittest.py \
-       test/ganeti.serializer_unittest.py \
-       test/ganeti.server.rapi_unittest.py \
-       test/ganeti.ssconf_unittest.py \
-       test/ganeti.ssh_unittest.py \
-       test/ganeti.storage_unittest.py \
-       test/ganeti.tools.ensure_dirs_unittest.py \
-       test/ganeti.tools.node_daemon_setup_unittest.py \
-       test/ganeti.tools.prepare_node_join_unittest.py \
-       test/ganeti.uidpool_unittest.py \
-       test/ganeti.utils.algo_unittest.py \
-       test/ganeti.utils.filelock_unittest.py \
-       test/ganeti.utils.hash_unittest.py \
-       test/ganeti.utils.io_unittest-runasroot.py \
-       test/ganeti.utils.io_unittest.py \
-       test/ganeti.utils.log_unittest.py \
-       test/ganeti.utils.mlock_unittest.py \
-       test/ganeti.utils.nodesetup_unittest.py \
-       test/ganeti.utils.process_unittest.py \
-       test/ganeti.utils.retry_unittest.py \
-       test/ganeti.utils.text_unittest.py \
-       test/ganeti.utils.wrapper_unittest.py \
-       test/ganeti.utils.x509_unittest.py \
-       test/ganeti.utils_unittest.py \
-       test/ganeti.vcluster_unittest.py \
-       test/ganeti.workerpool_unittest.py \
-       test/pycurl_reset_unittest.py \
-       test/qa.qa_config_unittest.py \
-       test/tempfile_fork_unittest.py
-
-haskell_tests = htest/test
+       test/py/cfgupgrade_unittest.py \
+       test/py/docs_unittest.py \
+       test/py/ganeti.asyncnotifier_unittest.py \
+       test/py/ganeti.backend_unittest-runasroot.py \
+       test/py/ganeti.backend_unittest.py \
+       test/py/ganeti.bdev_unittest.py \
+       test/py/ganeti.cli_unittest.py \
+       test/py/ganeti.client.gnt_cluster_unittest.py \
+       test/py/ganeti.client.gnt_instance_unittest.py \
+       test/py/ganeti.client.gnt_job_unittest.py \
+       test/py/ganeti.cmdlib_unittest.py \
+       test/py/ganeti.compat_unittest.py \
+       test/py/ganeti.confd.client_unittest.py \
+       test/py/ganeti.config_unittest.py \
+       test/py/ganeti.constants_unittest.py \
+       test/py/ganeti.daemon_unittest.py \
+       test/py/ganeti.errors_unittest.py \
+       test/py/ganeti.hooks_unittest.py \
+       test/py/ganeti.ht_unittest.py \
+       test/py/ganeti.http_unittest.py \
+       test/py/ganeti.hypervisor.hv_chroot_unittest.py \
+       test/py/ganeti.hypervisor.hv_fake_unittest.py \
+       test/py/ganeti.hypervisor.hv_kvm_unittest.py \
+       test/py/ganeti.hypervisor.hv_lxc_unittest.py \
+       test/py/ganeti.hypervisor.hv_xen_unittest.py \
+       test/py/ganeti.hypervisor_unittest.py \
+       test/py/ganeti.impexpd_unittest.py \
+       test/py/ganeti.jqueue_unittest.py \
+       test/py/ganeti.jstore_unittest.py \
+       test/py/ganeti.locking_unittest.py \
+       test/py/ganeti.luxi_unittest.py \
+       test/py/ganeti.masterd.iallocator_unittest.py \
+       test/py/ganeti.masterd.instance_unittest.py \
+       test/py/ganeti.mcpu_unittest.py \
+       test/py/ganeti.netutils_unittest.py \
+       test/py/ganeti.objects_unittest.py \
+       test/py/ganeti.objectutils_unittest.py \
+       test/py/ganeti.opcodes_unittest.py \
+       test/py/ganeti.ovf_unittest.py \
+       test/py/ganeti.qlang_unittest.py \
+       test/py/ganeti.query_unittest.py \
+       test/py/ganeti.rapi.baserlib_unittest.py \
+       test/py/ganeti.rapi.client_unittest.py \
+       test/py/ganeti.rapi.resources_unittest.py \
+       test/py/ganeti.rapi.rlib2_unittest.py \
+       test/py/ganeti.rapi.testutils_unittest.py \
+       test/py/ganeti.rpc_unittest.py \
+       test/py/ganeti.runtime_unittest.py \
+       test/py/ganeti.serializer_unittest.py \
+       test/py/ganeti.server.rapi_unittest.py \
+       test/py/ganeti.ssconf_unittest.py \
+       test/py/ganeti.ssh_unittest.py \
+       test/py/ganeti.storage_unittest.py \
+       test/py/ganeti.tools.ensure_dirs_unittest.py \
+       test/py/ganeti.tools.node_daemon_setup_unittest.py \
+       test/py/ganeti.tools.prepare_node_join_unittest.py \
+       test/py/ganeti.uidpool_unittest.py \
+       test/py/ganeti.utils.algo_unittest.py \
+       test/py/ganeti.utils.filelock_unittest.py \
+       test/py/ganeti.utils.hash_unittest.py \
+       test/py/ganeti.utils.io_unittest-runasroot.py \
+       test/py/ganeti.utils.io_unittest.py \
+       test/py/ganeti.utils.log_unittest.py \
+       test/py/ganeti.utils.lvm_unittest.py \
+       test/py/ganeti.utils.mlock_unittest.py \
+       test/py/ganeti.utils.nodesetup_unittest.py \
+       test/py/ganeti.utils.process_unittest.py \
+       test/py/ganeti.utils.retry_unittest.py \
+       test/py/ganeti.utils.text_unittest.py \
+       test/py/ganeti.utils.wrapper_unittest.py \
+       test/py/ganeti.utils.x509_unittest.py \
+       test/py/ganeti.utils_unittest.py \
+       test/py/ganeti.vcluster_unittest.py \
+       test/py/ganeti.workerpool_unittest.py \
+       test/py/pycurl_reset_unittest.py \
+       test/py/qa.qa_config_unittest.py \
+       test/py/tempfile_fork_unittest.py
+
+haskell_tests = test/hs/htest
 
 dist_TESTS = \
-       test/check-cert-expired_unittest.bash \
-       test/daemon-util_unittest.bash \
-       test/ganeti-cleaner_unittest.bash \
-       test/import-export_unittest.bash \
-       test/cli-test.bash \
-       test/bash_completion.bash \
+       test/py/check-cert-expired_unittest.bash \
+       test/py/daemon-util_unittest.bash \
+       test/py/ganeti-cleaner_unittest.bash \
+       test/py/import-export_unittest.bash \
+       test/py/cli-test.bash \
+       test/py/bash_completion.bash \
        $(python_tests)
 
 nodist_TESTS =
 check_SCRIPTS =
 
-if WANT_HTOOLSTESTS
+if WANT_HSTESTS
 nodist_TESTS += $(haskell_tests)
-dist_TESTS += htest/offline-test.sh
+dist_TESTS += test/hs/offline-test.sh
 check_SCRIPTS += \
-       htest/hpc-htools \
-       htest/hpc-mon-collector \
+       test/hs/hpc-htools \
+       test/hs/hpc-mon-collector \
        $(HS_BUILT_TEST_HELPERS)
 endif
 
@@ -1092,16 +1114,17 @@ all_python_code = \
 
 srclink_files = \
        man/footer.rst \
-       test/check-cert-expired_unittest.bash \
-       test/daemon-util_unittest.bash \
-       test/ganeti-cleaner_unittest.bash \
-       test/import-export_unittest.bash \
-       test/cli-test.bash \
-       test/bash_completion.bash \
-       htest/offline-test.sh \
-       htest/cli-tests-defs.sh \
+       test/py/check-cert-expired_unittest.bash \
+       test/py/daemon-util_unittest.bash \
+       test/py/ganeti-cleaner_unittest.bash \
+       test/py/import-export_unittest.bash \
+       test/py/cli-test.bash \
+       test/py/bash_completion.bash \
+       test/hs/offline-test.sh \
+       test/hs/cli-tests-defs.sh \
        $(all_python_code) \
-       $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
+       $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
+       $(docinput)
 
 check_python_code = \
        $(BUILD_BASH_COMPLETION) \
@@ -1138,11 +1161,11 @@ pep8_python_code = \
        $(PYTHON_BOOTSTRAP) \
        qa
 
-test/daemon-util_unittest.bash: daemons/daemon-util
+test/py/daemon-util_unittest.bash: daemons/daemon-util
 
-test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
+test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
 
-test/bash_completion.bash: doc/examples/bash_completion-debug
+test/py/bash_completion.bash: doc/examples/bash_completion-debug
 
 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
@@ -1166,54 +1189,40 @@ doc/examples/bash_completion doc/examples/bash_completion-debug: \
        $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
        lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
        daemons/ganeti-cleaner \
-       $(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
+       $(GENERATED_FILES) $(HS_GENERATED_FILES)
        PYTHONPATH=. $(RUN_IN_TEMPDIR) \
          $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
 
-doc/%.png: doc/%.dot
-       @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
-       $(DOT) -Tpng -o $@ $<
-
-man/footer.man: man/footer.rst
-       @test -n "$(PANDOC)" || \
-         { echo 'pandoc' not found during configure; exit 1; }
-       $(PANDOC) -f rst -t man -o $@ $<
-
-man/footer.html: man/footer.rst
-       @test -n "$(PANDOC)" || \
-         { echo 'pandoc' not found during configure; exit 1; }
-       $(PANDOC) -f rst -t html -o $@ $<
-
 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
        lib/build/shell_example_lexer.py \
        | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
        @echo "Checking $< for hardcoded paths..."
        @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
-         echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
+         echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
          exit 1; \
        fi
        set -e ; \
        trap 'echo auto-removing $@; rm $@' EXIT; \
        PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
+       $(CHECK_MAN_REFERENCES) $@; \
        trap - EXIT
 
-man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
+man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
        @test -n "$(PANDOC)" || \
          { echo 'pandoc' not found during configure; exit 1; }
        set -o pipefail ; \
        trap 'echo auto-removing $@; rm $@' EXIT; \
-       $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
+       $(PANDOC) -s -f rst -t man $< man/footer.rst | \
          sed -e 's/\\@/@/g' > $@; \
        if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
        $(CHECK_MAN_DASHES) $@; \
        trap - EXIT
 
-
-man/%.html.in: man/%.gen man/footer.html
+man/%.html.in: man/%.gen man/footer.rst
        @test -n "$(PANDOC)" || \
          { echo 'pandoc' not found during configure; exit 1; }
        set -o pipefail ; \
-       $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
+       $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
          sed -e 's/\\@/@/g' > $@
 
 man/%: man/%.in  $(REPLACE_VARS_SED)
@@ -1245,26 +1254,28 @@ regen-vcs-version:
          fi; \
        fi
 
-htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
+src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
        vcs-version $(built_base_sources)
        set -e; \
        VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
        sed -e "s/%ver%/$$VCSVER/" < $< > $@
 
-htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
+src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
        lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
-       lib/jstore.py \
+       lib/jstore.py $(RUN_IN_TEMPDIR) \
        $(CONVERT_CONSTANTS) $(built_base_sources) \
        | lib/_vcsversion.py
        set -e; \
-       { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
+       { cat $< ; \
+         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
+       } > $@
 
-htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
+test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
        $(built_base_sources)
        set -e; \
        { cat $< ; \
          echo ; \
-         for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
+         for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
            echo "import $$name ()" ; \
          done ; \
        } > $@
@@ -1423,7 +1434,7 @@ tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
-$(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
+$(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
 
 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
        test -n "$(MODULE)" || { echo Missing module; exit 1; }
@@ -1459,7 +1470,7 @@ $(HS_BUILT_TEST_HELPERS): Makefile
          echo '# This file is automatically generated, do not edit!'; \
          echo "# Edit Makefile.am instead."; \
          echo; \
-         echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
+         echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
        } > $@
        chmod u+x $@
 
@@ -1541,11 +1552,18 @@ check-local: check-dirs $(GENERATED_FILES)
        done; \
        test -z "$$error"
 
+.PHONY: hs-tests
+hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
+       @rm -f htest.tix
+       ./test/hs/htest
+
+.PHONY: hs-shell
+hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
+       @rm -f hpc-htools.tix hpc-mon-collector.tix
+       HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
+
 .PHONY: hs-check
-hs-check: htest/test htest/hpc-htools htest/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
-       @rm -f *.tix
-       ./htest/test
-       HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
+hs-check: hs-tests hs-shell
 
 # E111: indentation is not a multiple of four
 # E121: continuation line indentation is not a multiple of four
@@ -1595,9 +1613,9 @@ pep8: $(GENERATED_FILES)
          --repeat $(pep8_python_code)
 
 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
-HLINT_EXCLUDES = htools/Ganeti/THH.hs htest/hpc-htools.hs
+HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
 .PHONY: hlint
-hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
+hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
        @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
        if tty -s; then C="-c"; else C=""; fi; \
        $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
@@ -1605,7 +1623,7 @@ hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
          --ignore "Use &&&" \
          --ignore "Use void" \
          --ignore "Reduce duplication" \
-         --hint htools/lint-hints \
+         --hint src/lint-hints \
          $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
 
 # a dist hook rule for updating the vcs-version file; this is
@@ -1675,7 +1693,7 @@ install-exec-local:
          "$(DESTDIR)${localstatedir}/run/ganeti"
 
 .PHONY: apidoc
-if WANT_HTOOLSAPIDOC
+if WANT_HSAPIDOC
 apidoc: py-apidoc hs-apidoc
 else
 apidoc: py-apidoc
@@ -1702,18 +1720,18 @@ hs-apidoc: $(HS_BUILT_SRCS)
        $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
        $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
        set -e ; \
-       cd htools; \
-       if [ "$(HTOOLS_NOCURL)" ]; \
-       then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
+       cd src; \
+       if [ "$(HS_NOCURL)" ]; \
+       then OPTGHC="--optghc=$(HS_NOCURL)"; \
        else OPTGHC=""; \
        fi; \
-       if [ "$(HTOOLS_PARALLEL3)" ]; \
-       then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
+       if [ "$(HS_PARALLEL3)" ]; \
+       then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
        fi; \
-       if [ "$(HTOOLS_REGEX_PCRE)" ]; \
-       then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_REGEX_PCRE)"; \
+       if [ "$(HS_REGEX_PCRE)" ]; \
+       then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
        fi; \
-       RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
+       RELSRCS="$(HS_LIB_SRCS:src/%=%) $(patsubst src/%,%,$(filter src/%,$(HS_BUILT_SRCS)))"; \
        for file in $$RELSRCS; do \
          hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
          $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
@@ -1723,14 +1741,14 @@ hs-apidoc: $(HS_BUILT_SRCS)
          --source-module="%{MODULE/.//}.html" \
          --source-entity="%{MODULE/.//}.html#%{NAME}" \
          $$OPTGHC \
-         $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
+         $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:src/%=%))
 
 .PHONY: TAGS
 TAGS: $(GENERATED_FILES)
        rm -f TAGS
        $(GHC) -e ":etags" -v0 \
          $(filter-out -O -Werror,$(HFLAGS)) \
-         $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
+         $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
          $(HS_LIBTEST_SRCS)
        find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
          -path './daemons/ganeti-*' -o -path './tools/*' -o \
@@ -1753,18 +1771,19 @@ py-coverage: $(GENERATED_FILES) $(python_tests)
        COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
        TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
        HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
-       $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
+       $(PLAIN_TESTS_ENVIRONMENT) \
+       $(abs_top_srcdir)/autotools/gen-py-coverage \
        $(python_tests)
 
 .PHONY: hs-coverage
-hs-coverage: $(haskell_tests) htest/hpc-htools htest/hpc-mon-collector
+hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
        rm -f *.tix
        $(MAKE) $(AM_MAKEFLAGS) hs-check
        @mkdir_p@ $(COVERAGE_HS_DIR)
        hpc sum --union $(HPCEXCL) \
-         test.tix hpc-htools.tix hpc-mon-collector.tix > coverage-htools.tix
-       hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
-       hpc report coverage-htools.tix
+         htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
+       hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
+       hpc report coverage-hs.tix
        $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
 
 # Special "kind-of-QA" target for htools, needs special setup (all
@@ -1772,11 +1791,11 @@ hs-coverage: $(haskell_tests) htest/hpc-htools htest/hpc-mon-collector
 .PHONY: live-test
 live-test: all
        set -e ; \
-       cd htools; \
+       cd src; \
        rm -f .hpc; $(LN_S) ../.hpc .hpc; \
        rm -f *.tix *.mix; \
        ./live-test.sh; \
-       hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
+       hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
          --output=live-test.tix ; \
        @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
        hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
@@ -1793,6 +1812,10 @@ gitignore-check:
          exit 1; \
        fi
 
+# target to rebuild all man pages (both groff and html output)
+.PHONY: man
+man: $(man_MANS) $(manhtml)
+
 # Target that builds all binaries (including those that are not
 # rebuilt except when running the tests)
 .PHONY: really-all